package io.xjar.boot;

import java.net.URL;
import java.net.URLClassLoader;
import org.springframework.boot.loader.archive.Archive;
import java.util.List;
import io.xjar.XLauncher;
import org.springframework.boot.loader.PropertiesLauncher;

public class XExtLauncher extends PropertiesLauncher
{
    private final XLauncher xLauncher;
    
    public XExtLauncher(final String... args) throws Exception {
        this.xLauncher = new XLauncher(args);
    }
    
    public static void main(final String[] args) throws Exception {
        new XExtLauncher(args).launch();
    }
    
    public void launch() throws Exception {
        this.launch(this.xLauncher.args);
    }
    
    protected ClassLoader createClassLoader(final List<Archive> archives) throws Exception {
        final URLClassLoader classLoader = (URLClassLoader)super.createClassLoader((List)archives);
        final URL[] urls = classLoader.getURLs();
        return (ClassLoader)new XBootClassLoader(urls, this.getClass().getClassLoader(), this.xLauncher.xDecryptor, this.xLauncher.xEncryptor, this.xLauncher.xKey);
    }
}
